/*********************************************************************
 *                
 * Copyright (C) 2003-2004,  National ICT Australia (NICTA)
 *                
 * File path:     arch/arm/debug.h
 * Description:   Debug support
 *                
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *                
 * $Id: debug.h,v 1.7 2004/06/04 02:14:22 cvansch Exp $
 *                
 ********************************************************************/

#ifndef __ARCH__ARM__DEBUG_H__
#define __ARCH__ARM__DEBUG_H__

#include INC_GLUE(syscalls.h)
#include INC_ARCH(thread.h)

#if !defined(ASSEMBLY)

INLINE void spin_forever(int pos = 0)
{
    while(1) { }
}

INLINE void spin(int pos = 0, int cpu = 0)
{
}

extern "C" void arm_misc_l4_syscall(arm_irq_context_t *context);

INLINE void enter_kdebug(char *s)
{
    arm_irq_context_t context;
    context.r12 = L4_TRAP_KDEBUG;
    context.cpsr = 0;
    context.r0 = (word_t)s;
    arm_misc_l4_syscall(&context);
}

#define HERE()		printf("Here %s:%d\n", __PRETTY_FUNCTION__, __LINE__)

#if defined(__RVCT__)
/* XXX: We want to prevent RVCT from using its builtin printf */
#define printf		printk
#endif

#endif /* ! ASSEMBLY */

#endif /* __ARCH__ARM__DEBUG_H__ */
