/*********************************************************************
 *                
 * Copyright (C) 2002, 2003,  Karlsruhe University
 *                
 * File path:     config.h
 * Description:   global configuration, include wrapper
 *		  all config files should have constant
 *                declarations only!!!
 *                
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *                
 * $Id: config.h,v 1.4 2003/09/24 19:04:24 skoglund Exp $
 *                
 ********************************************************************/
#ifndef __CONFIG_H__
#define __CONFIG_H__

/* default system is uniprocessor - override in CFLAGS if neccesary */
#ifndef CONFIG_NUM_DOMAINS
#define CONFIG_NUM_DOMAINS 1
#endif

#ifndef CONFIG_NUM_UNITS
#define CONFIG_NUM_UNITS 1
#endif

#define CONFIG_MAX_UNITS_PER_DOMAIN CONFIG_NUM_UNITS / CONFIG_NUM_DOMAINS

/**
 * SMP derives
 */
#if defined(CONFIG_NUM_DOMAINS) && CONFIG_NUM_DOMAINS > 1
#define CONFIG_MDOMAINS
#endif

#if defined(CONFIG_NUM_UNITS) && CONFIG_NUM_UNITS > 1
#define CONFIG_MUNITS
#endif

#include INC_API(config.h)
#include INC_GLUE(config.h)

#endif /* !__CONFIG_H__ */
