/*********************************************************************
 *
 * Copyright (C) 2003-2006,  National ICT Australia (NICTA)
 *
 * File path:     platform/at91rm9200/console.h
 * Description:   AT91RM9200 console constants
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 ********************************************************************/

#ifndef __PLATFORM__AT91RM9200__CONSOLE_H_
#define __PLATFORM__AT91RM9200__CONSOLE_H_

#include	INC_PLAT(offsets.h)

#if defined(CONFIG_DBGU)

/* Atmel AT91RM9200 Debug Serial Port */
#define CONSOLE_OFFSET	0x200
#define CONSOLE_VADDR	(SYS_VADDR | CONSOLE_OFFSET)
#undef USART_PADDR

#elif defined(CONFIG_USART0)

#define CONSOLE_VADDR	(SYS_USART)
#define USART_PADDR	(PHYS_USART0)

#elif defined(CONFIG_USART1)

#define CONSOLE_VADDR	(SYS_USART)
#define USART_PADDR	(PHYS_USART1)

#elif defined(CONFIG_USART2)

#define CONSOLE_VADDR	(SYS_USART)
#define USART_PADDR	(PHYS_USART2)

#elif defined(CONFIG_USART3)

#define CONSOLE_VADDR	(SYS_USART)
#define USART_PADDR	(PHYS_USART3)

#else
#error invalid UART / no uart specified
#endif

#endif /* __PLATFORM__AT91RM9200__CONSOLE_H_ */
